package org.spotlightor 
{
	import com.bit101.components.ComboBox;
	import com.bit101.components.HUISlider;
	import com.bit101.components.RadioButton;
	import com.bit101.components.Slider;
	import com.gskinner.geom.ColorMatrix;
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.BlendMode;
	import flash.display.DisplayObject;
	import flash.display.DisplayObjectContainer;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.events.StatusEvent;
	import flash.filters.BlurFilter;
	import flash.filters.ColorMatrixFilter;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import flash.media.Camera;
	import flash.media.Video;
	/**
	 * ...
	 * @author 高鸣 - 交典创艺 (Spotlightor.com)
	 */
	public class BloomEffect extends Sprite
	{
		protected static const ZERO_POINT:Point = new Point(0, 0);
		
		protected var _cam:Camera;
		protected var _video:Video;
		
		protected var _bloomSprite:Sprite;
		protected var _bloomBitmap:Bitmap;
		
		protected var _bloomBlurFilter:BlurFilter;
		protected var _colorMatrix:ColorMatrix;
		protected var _colorMatrixFilter:ColorMatrixFilter;
		
		protected var _videoLayoutHelper:DisplayObject;
		protected var _uiLayoutHelper:DisplayObjectContainer;
		
		private var _birghtnessSlider:HUISlider;
		private var _contrastSlider:HUISlider;
		
		public function BloomEffect() 
		{
			_videoLayoutHelper = mc_video;
			_uiLayoutHelper = mc_ui as DisplayObjectContainer;
			
			_cam = Camera.getCamera();
			if (_cam)
			{
				_video = new Video(320, 240);
				_cam.addEventListener(StatusEvent.STATUS, onCameraStatus);
				_video.attachCamera(_cam);
			}
		}
		
		private function onCameraStatus(e:StatusEvent):void 
		{
			_bloomSprite = addChild(new Sprite()) as Sprite;
			_bloomSprite.scrollRect = new Rectangle(0, 0, 320, 240);
			
			_bloomSprite.addChild(_video);
			_bloomSprite.x = _videoLayoutHelper.x;
			_bloomSprite.y = _videoLayoutHelper.y;
			
			_bloomBitmap = new Bitmap(new BitmapData(320, 240, false));
			_bloomBitmap.blendMode = BlendMode.SCREEN;
			_bloomSprite.addChild(_bloomBitmap);
			
			_bloomBlurFilter = new BlurFilter(16, 16, 1); 
			
			_colorMatrix = new ColorMatrix();
			_colorMatrixFilter = new ColorMatrixFilter();
			
			_bloomBitmap.filters = [_colorMatrixFilter];
			
			addEventListener(Event.ENTER_FRAME, onFrameApplyBloomEffect);
			
			createUI();
		}
		
		private function onFrameApplyBloomEffect(e:Event):void 
		{
			bloomData.draw(_video);
			bloomData.applyFilter(bloomData, bloomData.rect, ZERO_POINT, _bloomBlurFilter);
		}
		
		protected function get bloomData():BitmapData {
			return _bloomBitmap.bitmapData;
		}
		
		private function createUI():void
		{
			
			new RadioButton(this, _uiLayoutHelper.x, _uiLayoutHelper.y, "screen", true, onSelectBlendMode);
			new RadioButton(this, _uiLayoutHelper.x, _uiLayoutHelper.y + 20, "add", false, onSelectBlendMode);
			new RadioButton(this, _uiLayoutHelper.x, _uiLayoutHelper.y + 40, "lighten", false, onSelectBlendMode);
			new RadioButton(this, _uiLayoutHelper.x, _uiLayoutHelper.y + 60, "overlay", false, onSelectBlendMode);
			new RadioButton(this, _uiLayoutHelper.x, _uiLayoutHelper.y + 80, "hardlight", false, onSelectBlendMode);
			
			var blurSlider:HUISlider = new HUISlider(this, _uiLayoutHelper.x, _uiLayoutHelper.y + 100, "Blur Radius", onSlideBlur);
			blurSlider.tick = 1;
			blurSlider.value = 16;
			blurSlider.maximum = 32;
			blurSlider.minimum = 2;
			
			var qualitySlider:HUISlider = new HUISlider(this, _uiLayoutHelper.x, _uiLayoutHelper.y + 120, "Blur Quality", onSlideQuality);
			qualitySlider.value = 1;
			qualitySlider.maximum = 3;
			qualitySlider.minimum = 1;
			qualitySlider.tick = 1;
			
			_birghtnessSlider = new HUISlider(this, _uiLayoutHelper.x, _uiLayoutHelper.y + 140, "brightness", onSlideBrightnessContrast);
			_birghtnessSlider.value = 30;
			_birghtnessSlider.maximum = 100;
			_birghtnessSlider.minimum = -100;
			_birghtnessSlider.tick = 1;
			
			_contrastSlider = new HUISlider(this, _uiLayoutHelper.x, _uiLayoutHelper.y + 160, "contrast", onSlideBrightnessContrast);
			_contrastSlider.value = 30;
			_contrastSlider.maximum = 100;
			_contrastSlider.minimum = -100;
			_contrastSlider.tick = 1;
		}
		
		private function onSlideBrightnessContrast(e:Event):void
		{
			if (_contrastSlider && _birghtnessSlider)
			{
				_colorMatrix = new ColorMatrix();
				_colorMatrix.adjustColor(_birghtnessSlider.value, _contrastSlider.value, 0, 0);
				_colorMatrixFilter = new ColorMatrixFilter(_colorMatrix);
				_bloomBitmap.filters = [_colorMatrixFilter];
			}
		}
		
		private function onSlideQuality(e:Event):void
		{
			var slider:HUISlider = e.target as HUISlider;
			_bloomBlurFilter.quality = slider.value;
		}
		
		private function onSlideBlur(e:Event):void
		{
			var slider:HUISlider = e.target as HUISlider;
			_bloomBlurFilter.blurX = slider.value;
			_bloomBlurFilter.blurY = slider.value;
		}
		
		private function onSelectBlendMode(e:Event):void
		{
			_bloomBitmap.blendMode = (e.target as RadioButton).label;
		}
		
	}

}